<?php
#
# $Id: check_memory.php 422 2014-08-20 14:18:15Z phil $
# 
# pnp4nagios template for check_memory.
#
# use RRD_STORAGE_TYPE = MULTIPLE.
#
# Author: Philippe Kueck <projects at unixadm dot org>

$myds = array();
for ($i = 1; $i <= count($DS); $i++) {$myds[$NAME[$i]] = $i;}

$i = 0;
$opt[$i] = "";
$def[$i] = "";
$ds_name[$i] = "Memory Statistics";

function getMulti($unit) {
	switch ($unit) {
		case  'B': return 1; break;
		case 'KB': return pow(2,10); break;
		case 'MB': return pow(2,20); break;
		case 'GB': return pow(2,30); break;
		case 'TB': return pow(2,40); break;
	}
}


$opt[$i] = " --vertical-label \"Memory\" -b 1024 -E --title \"Memory Statistics for $hostname\" ";
$c = 0; foreach (
		array('MemTotal' => 'total memory', 'MemFree' => 'free memory',
		'Buffers' => 'file buffers', 'Cached' => 'cache memory', 'Slab' => 'slab')
		as $k => $d) {

	$def[$i] .= rrd::def("r_$k", $RRDFILE[$myds[$k]], $DS[$myds[$k]], "AVERAGE");
	$def[$i] .= rrd::cdef($k, "r_$k,".getMulti($UNIT[$myds[$k]]).",*");

	if ($k == "MemTotal") {
		$def[$i] .= rrd::line1($k, "#000000", rrd::cut($d, 20));
	} elseif ($k == "MemFree") {
		$warn = $WARN[$myds[$k]] * getMulti($UNIT[$myds[$k]]);
		$crit = $CRIT[$myds[$k]] * getMulti($UNIT[$myds[$k]]);
		$def[$i] .= rrd::alerter_gr($k, rrd::cut($d, 20), $warn, $crit, 'FF', 'B', '#00a000', '#606000', '#a00000', '#00a000', '#efffef');
#		$def[$i] .= rrd::line1($k, "#00ff00", rrd::cut($d, 20));
	} else {
		$def[$i] .= rrd::line1($k, rrd::color($c++), rrd::cut($d, 20));
	}
	$def[$i] .= rrd::gprint($k, array("LAST", "AVERAGE", "MAX"), "%7.2lf %sB");
}

$i++;
$opt[$i] = " --vertical-label \"Swap Space\" -b 1024 -E --title \"Swap Statistics for $hostname\" ";
$def[$i] = "";
$ds_name[$i] = "Swap Statistics";
$c = 0; foreach (
		array('SwapTotal' => 'total swap space', 'SwapFree' => 'free swap space',
		'SwapCached' => 'cache in swap')
		as $k => $d) {
	$def[$i] .= rrd::def("r_$k", $RRDFILE[$myds[$k]], $DS[$myds[$k]], "AVERAGE");
	$def[$i] .= rrd::cdef($k, "r_$k,".getMulti($UNIT[$myds[$k]]).",*");

	if ($k == "SwapFree") {
		$def[$i] .= rrd::alerter_gr($k, rrd::cut($d, 20), $WARN[$myds[$k]], $CRIT[$myds[$k]], 'FF', 'B', '#008000', '#008080', '#800000', '#008000', '#efffef');
	} else {
		$def[$i] .= rrd::line1($k, rrd::color($c++), rrd::cut($d, 20));
	}
	$def[$i] .= rrd::gprint($k, array("LAST", "AVERAGE", "MAX"), "%7.2lf %sB");
}

$i++;
$opt[$i] = " --vertical-label \"Virtual Memory\" -b 1024 -E --title \"Virtual Memory Statistics for $hostname\" ";
$def[$i] = "";
$ds_name[$i] = "VM Statistics";
$c = 0; foreach (
		array('Active' => 'in active use', 'Inactive' => 'available memory',
		'Dirty' => 'dirty/wait for write', 'VmallocUsed' => 'total used')
		as $k => $d) {
	$def[$i] .= rrd::def("r_$k", $RRDFILE[$myds[$k]], $DS[$myds[$k]], "AVERAGE");
	$def[$i] .= rrd::cdef($k, "r_$k,".getMulti($UNIT[$myds[$k]]).",*");
	$def[$i] .= rrd::line1($k, rrd::color($c++), rrd::cut($d, 20));
	$def[$i] .= rrd::gprint($k, array("LAST", "AVERAGE", "MAX"), "%7.2lf %SB");
}

?>
